/*
 * Functions.c

 *
 *  Created on: 22 mag 2017
 *      Author: Giovanni Trotta
 */


#include "functions.h"

extern ADC_HandleTypeDef ADCHandle;


void Init_Led(){
	 /* -1- Enable GPIOE Clock (to be able to program the configuration registers) */
	  __HAL_RCC_GPIOE_CLK_ENABLE();
	  GPIO_InitTypeDef  GPIO_LedStruct;

	  /* -2- Configure PE.8 to PE.15 IOs in output push-pull mode to drive external LEDs */
	  GPIO_LedStruct.Pin = (GPIO_PIN_15 |GPIO_PIN_14 |GPIO_PIN_13 |GPIO_PIN_12 |GPIO_PIN_11 | GPIO_PIN_10 | GPIO_PIN_9 | GPIO_PIN_8);
	  GPIO_LedStruct.Mode = GPIO_MODE_OUTPUT_PP;
	  GPIO_LedStruct.Pull = GPIO_PULLUP;
	  GPIO_LedStruct.Speed = GPIO_SPEED_FREQ_HIGH;

	  HAL_GPIO_Init(GPIOE, &GPIO_LedStruct);

}



void Init_Button(){
	 GPIO_InitTypeDef  GPIO_ButtonStruct;
	 /* -1- Enable GPIOA Clock (to be able to program the configuration registers) */
	  __HAL_RCC_GPIOA_CLK_ENABLE();

	  GPIO_ButtonStruct.Pin = GPIO_PIN_0;
	  GPIO_ButtonStruct.Mode = GPIO_MODE_INPUT;
	  GPIO_ButtonStruct.Pull = GPIO_NOPULL;
	  GPIO_ButtonStruct.Speed = GPIO_SPEED_FREQ_HIGH;

	  HAL_GPIO_Init(GPIOA, &GPIO_ButtonStruct);

}

void Init_ADC(){

	ADC_ChannelConfTypeDef sConfig;

	__HAL_RCC_ADC1_CLK_ENABLE();

	ADCHandle.Instance = ADC1;
	ADCHandle.Init.ClockPrescaler = ADC_CLOCKPRESCALER_PCLK_DIV1;
	ADCHandle.Init.Resolution = ADC_RESOLUTION_12B;
	ADCHandle.Init.ScanConvMode = DISABLE;
	ADCHandle.Init.ContinuousConvMode = ENABLE;
	ADCHandle.Init.DiscontinuousConvMode = DISABLE;
	ADCHandle.Init.NbrOfDiscConversion = 0;
	ADCHandle.Init.ExternalTrigConvEdge = ADC_EXTERNALTRIGCONVEDGE_NONE;
	ADCHandle.Init.ExternalTrigConv = ADC_EXTERNALTRIGCONV_T1_CC1;
	ADCHandle.Init.DataAlign = ADC_DATAALIGN_RIGHT;
	ADCHandle.Init.NbrOfConversion = 1;
	ADCHandle.Init.DMAContinuousRequests = ENABLE;
	ADCHandle.Init.EOCSelection = DISABLE;

	HAL_ADC_Init(&ADCHandle);

	//The temperature sensor is internally connected to channel ADC1_IN16.
	sConfig.Channel = ADC_CHANNEL_16;
	sConfig.Rank = 1;
	sConfig.SamplingTime = ADC_SAMPLETIME_61CYCLES_5;
	sConfig.Offset = 0;

	HAL_ADC_ConfigChannel(&ADCHandle, &sConfig);
	HAL_ADC_Start(&ADCHandle);

}
